function init_particles(w, h)
	particle_size = math.floor((w*h)^0.5/500.0) or 1
	bub_border = 3
	
	bubble = love.graphics.newCanvas(2*(particle_size+bub_border), 2*(particle_size+bub_border))
	
	bc_shaders.blur:send("width", 2.0*(particle_size+bub_border))
	bc_shaders.blur:send("height", 2.0*(particle_size+bub_border))

	love.graphics.setCanvas(bubble)
	love.graphics.setColor(0, 0, 0)
	love.graphics.rectangle("fill", 0, 0, 2*(particle_size+bub_border), 2*(particle_size+bub_border))
	love.graphics.setColor(255, 255, 255)
	love.graphics.circle("fill", particle_size + bub_border, particle_size + bub_border, particle_size)
	
	love.graphics.setPixelEffect(bc_shaders.blur)
	love.graphics.draw(bubble, 0, 0)
	love.graphics.setPixelEffect()
	love.graphics.setCanvas()

	--Resend the standard values to the shader variables

	bc_shaders.blur:send("width", H_RES)
	bc_shaders.blur:send("height", V_RES)
end
