bc_shaders = {}

bc_shaders.blur = love.graphics.newPixelEffect [[
	
	extern number width;
	extern number height;
	
	number inv_w = 1.0/width;
	number inv_h = 1.0/height;
		
	vec4 effect(vec4 pix_col, Image texture, vec2 texture_coords, vec2 screen_coords)
	{
		vec4 sum = vec4(0.0);
		
		sum += (texture2D(texture, vec2(texture_coords.x-3.0*inv_w, texture_coords.y-3.0*inv_h)))*0.0058548875501775;
		sum += (texture2D(texture, vec2(texture_coords.x-3.0*inv_w, texture_coords.y-2.0*inv_h)))*0.010204536197191;
		sum += (texture2D(texture, vec2(texture_coords.x-3.0*inv_w, texture_coords.y-1.0*inv_h)))*0.014241577509041;
		sum += (texture2D(texture, vec2(texture_coords.x-3.0*inv_w, texture_coords.y+0.0*inv_h)))*0.015915234435318;
		sum += (texture2D(texture, vec2(texture_coords.x-3.0*inv_w, texture_coords.y+1.0*inv_h)))*0.014241577509041;
		sum += (texture2D(texture, vec2(texture_coords.x-3.0*inv_w, texture_coords.y+2.0*inv_h)))*0.010204536197191;
		sum += (texture2D(texture, vec2(texture_coords.x-3.0*inv_w, texture_coords.y+3.0*inv_h)))*0.0058548875501775;
		sum += (texture2D(texture, vec2(texture_coords.x-2.0*inv_w, texture_coords.y-3.0*inv_h)))*0.010204536197191;
		sum += (texture2D(texture, vec2(texture_coords.x-2.0*inv_w, texture_coords.y-2.0*inv_h)))*0.017785577964966;
		sum += (texture2D(texture, vec2(texture_coords.x-2.0*inv_w, texture_coords.y-1.0*inv_h)))*0.024821773595243;
		sum += (texture2D(texture, vec2(texture_coords.x-2.0*inv_w, texture_coords.y+0.0*inv_h)))*0.027738805312678;
		sum += (texture2D(texture, vec2(texture_coords.x-2.0*inv_w, texture_coords.y+1.0*inv_h)))*0.024821773595243;
		sum += (texture2D(texture, vec2(texture_coords.x-2.0*inv_w, texture_coords.y+2.0*inv_h)))*0.017785577964966;
		sum += (texture2D(texture, vec2(texture_coords.x-2.0*inv_w, texture_coords.y+3.0*inv_h)))*0.010204536197191;
		sum += (texture2D(texture, vec2(texture_coords.x-1.0*inv_w, texture_coords.y-3.0*inv_h)))*0.014241577509041;
		sum += (texture2D(texture, vec2(texture_coords.x-1.0*inv_w, texture_coords.y-2.0*inv_h)))*0.024821773595243;
		sum += (texture2D(texture, vec2(texture_coords.x-1.0*inv_w, texture_coords.y-1.0*inv_h)))*0.034641575642195;
		sum += (texture2D(texture, vec2(texture_coords.x-1.0*inv_w, texture_coords.y+0.0*inv_h)))*0.038712621351417;
		sum += (texture2D(texture, vec2(texture_coords.x-1.0*inv_w, texture_coords.y+1.0*inv_h)))*0.034641575642195;
		sum += (texture2D(texture, vec2(texture_coords.x-1.0*inv_w, texture_coords.y+2.0*inv_h)))*0.024821773595243;
		sum += (texture2D(texture, vec2(texture_coords.x-1.0*inv_w, texture_coords.y+3.0*inv_h)))*0.014241577509041;
		sum += (texture2D(texture, vec2(texture_coords.x+0.0*inv_w, texture_coords.y-3.0*inv_h)))*0.015915234435318;
		sum += (texture2D(texture, vec2(texture_coords.x+0.0*inv_w, texture_coords.y-2.0*inv_h)))*0.027738805312678;
		sum += (texture2D(texture, vec2(texture_coords.x+0.0*inv_w, texture_coords.y-1.0*inv_h)))*0.038712621351417;
		sum += (texture2D(texture, vec2(texture_coords.x+0.0*inv_w, texture_coords.y+0.0*inv_h)))*0.043262092561192;
		sum += (texture2D(texture, vec2(texture_coords.x+0.0*inv_w, texture_coords.y+1.0*inv_h)))*0.038712621351417;
		sum += (texture2D(texture, vec2(texture_coords.x+0.0*inv_w, texture_coords.y+2.0*inv_h)))*0.027738805312678;
		sum += (texture2D(texture, vec2(texture_coords.x+0.0*inv_w, texture_coords.y+3.0*inv_h)))*0.015915234435318;
		sum += (texture2D(texture, vec2(texture_coords.x+1.0*inv_w, texture_coords.y-3.0*inv_h)))*0.014241577509041;
		sum += (texture2D(texture, vec2(texture_coords.x+1.0*inv_w, texture_coords.y-2.0*inv_h)))*0.024821773595243;
		sum += (texture2D(texture, vec2(texture_coords.x+1.0*inv_w, texture_coords.y-1.0*inv_h)))*0.034641575642195;
		sum += (texture2D(texture, vec2(texture_coords.x+1.0*inv_w, texture_coords.y+0.0*inv_h)))*0.038712621351417;
		sum += (texture2D(texture, vec2(texture_coords.x+1.0*inv_w, texture_coords.y+1.0*inv_h)))*0.034641575642195;
		sum += (texture2D(texture, vec2(texture_coords.x+1.0*inv_w, texture_coords.y+2.0*inv_h)))*0.024821773595243;
		sum += (texture2D(texture, vec2(texture_coords.x+1.0*inv_w, texture_coords.y+3.0*inv_h)))*0.014241577509041;
		sum += (texture2D(texture, vec2(texture_coords.x+2.0*inv_w, texture_coords.y-3.0*inv_h)))*0.010204536197191;
		sum += (texture2D(texture, vec2(texture_coords.x+2.0*inv_w, texture_coords.y-2.0*inv_h)))*0.017785577964966;
		sum += (texture2D(texture, vec2(texture_coords.x+2.0*inv_w, texture_coords.y-1.0*inv_h)))*0.024821773595243;
		sum += (texture2D(texture, vec2(texture_coords.x+2.0*inv_w, texture_coords.y+0.0*inv_h)))*0.027738805312678;
		sum += (texture2D(texture, vec2(texture_coords.x+2.0*inv_w, texture_coords.y+1.0*inv_h)))*0.024821773595243;
		sum += (texture2D(texture, vec2(texture_coords.x+2.0*inv_w, texture_coords.y+2.0*inv_h)))*0.017785577964966;
		sum += (texture2D(texture, vec2(texture_coords.x+2.0*inv_w, texture_coords.y+3.0*inv_h)))*0.010204536197191;
		sum += (texture2D(texture, vec2(texture_coords.x+3.0*inv_w, texture_coords.y-3.0*inv_h)))*0.0058548875501775;
		sum += (texture2D(texture, vec2(texture_coords.x+3.0*inv_w, texture_coords.y-2.0*inv_h)))*0.010204536197191;
		sum += (texture2D(texture, vec2(texture_coords.x+3.0*inv_w, texture_coords.y-1.0*inv_h)))*0.014241577509041;
		sum += (texture2D(texture, vec2(texture_coords.x+3.0*inv_w, texture_coords.y+0.0*inv_h)))*0.015915234435318;
		sum += (texture2D(texture, vec2(texture_coords.x+3.0*inv_w, texture_coords.y+1.0*inv_h)))*0.014241577509041;
		sum += (texture2D(texture, vec2(texture_coords.x+3.0*inv_w, texture_coords.y+2.0*inv_h)))*0.010204536197191;
		sum += (texture2D(texture, vec2(texture_coords.x+3.0*inv_w, texture_coords.y+3.0*inv_h)))*0.0058548875501775;
		
		return sum;
	}
	
]]

bc_shaders.glow = love.graphics.newPixelEffect [[
	
	vec4 effect(vec4 pix_col, Image texture, vec2 texture_coords, vec2 screen_coords)
	{
		vec4 ans = vec4(0.0);
		if(ans.r > 0.7)
			ans.r = 1;
		if(ans.g > 0.7)
			ans.g = 1;
		if(ans.b > 0.7)
			ans.b = 1;
		if(ans.r < 0.3)
			ans.r = 0;
		if(ans.g < 0.3)
			ans.g = 0;
		if(ans.b < 0.3)
			ans.b = 0;
			
		return ans;
	}
	
]]
